package com.example.demo;

import java.awt.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Spliterator;
import java.util.function.Consumer;

public class People<PersonType extends Person> implements Iterable<PersonType> {

    private ArrayList<PersonType> personList = new ArrayList<>();

    public People(ArrayList<PersonType> personList) {
        this.personList = personList;
    }

    public People(PersonType... person) {
        personList.addAll(Arrays.asList(person));
    }

    public void add(PersonType person){
        personList.add(person);
    }

    public void remove(PersonType person){
        personList.remove(person);
    }

    public int size(){
       return personList.size();
    }

    public void clear(){
        personList.clear();
    }

    public void addAll(Iterable<PersonType> personsList){
        personsList.forEach(person -> personList.add(person));
    }

    public PersonType findById(Long id){
        for (PersonType person: personList) {
            if(person.getId() == id) {
                return person;
            }
        }
        return null;
    }

    public ArrayList<PersonType> findAll(){
        return personList;
    }

    @Override
    public Iterator<PersonType> iterator() {
        return personList.iterator();
    }

    @Override
    public void forEach(Consumer<? super PersonType> action) {

    }

    @Override
    public Spliterator<PersonType> spliterator() {
        return personList.spliterator();
    }
}
